<template>
  <PageWrapper dense>
    <Row>
      <!-- 左边部门选择 -->
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 4 }" class="h-[calc(100vh-80px)]">
        <DeptTree
          v-model:selectDeptId="selectDeptId"
          v-model:searchValue="searchValue"
          @select="reload"
        />
      </Col>
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 20 }">
        <BasicTable @register="registerTable">
          <template #toolbar>
            <a-button @click="handleImport" v-auth="'system:user:import'">导入</a-button>
            <a-button
              @click="
                downloadExcel(infoExport, '电梯基础信息;数据', getForm().getFieldsValue())
              "
              v-auth="'elevator:elevatorMange:export'"
              >导出</a-button
            >
            <a-button
              type="primary"
              danger
              @click="multipleRemove(infoRemove)"
              :disabled="!selected"
              v-auth="'elevator:elevatorMange:remove'"
              >删除</a-button
            >
            <a-button type="primary" @click="handleAdd" v-auth="'elevator:elevatorMange:add'"
              >新增</a-button
            >
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.dataIndex == 'useScenario'">
              <div>{{ findLabelByValue(record.useScenario, useMap) }}</div>
            </template>
            <template v-if="column.key === 'action'">
              <TableAction
                stopButtonPropagation
                :actions="[
                  {
                    label: '查看',

                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:elevatorMange:query',
                    onClick: handCheck.bind(null, record),
                  },
                  {
                    label: '修改',

                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:elevatorMange:edit',
                    onClick: handleEdit.bind(null, record),
                  },
                  {
                    label: '删除',

                    type: 'primary',
                    danger: true,
                    ghost: true,
                    auth: 'elevator:elevatorMange:remove',
                    popConfirm: {
                      placement: 'left',
                      title: '是否删除电梯基础信息;[' + record.id + ']?',
                      confirm: handleDelete.bind(null, record),
                    },
                  },
                ]"
                :dropDownActions="[
                  {
                    label: '维保',
                    icon: 'elevator:elevatorMange:mainitenance',
                    auth: '',

                    onClick: handleOpenAuth.bind(null, record),
                  },
                  {
                    label: '电梯配件设置',
                    icon: 'elevator:elevatorMange:access',
                    auth: '',

                    onClick: handleOpenAccess.bind(null, record),
                  },
                  {
                    label: '节能电梯设置',
                    icon: 'elevator:elevatorMange:energy',
                    auth: '',

                    onClick: handleOpenEnergy.bind(null, record),
                  },
                ]"
              />
            </template>
          </template>
        </BasicTable>
      </Col>
    </Row>
    <InfoModal @register="registerModal" @reload="reload" />
    <UserImportModal @register="registerImportModal" @reload="reload" />
    <MaintanceModal @register="registerMaintanceModal" />
    <AccessoriesModal @register="registerAccessModal" />
    <EnergyEva @register="registerEnergyModal" />
  </PageWrapper>
</template>

<script setup lang="ts">
import { Row, Col, Space, Avatar } from "ant-design-vue";
import { PageWrapper } from "@/components/Page";
import { BasicTable, useTable, TableAction } from "@/components/Table";
import { infoList, infoExport, infoRemove } from "@/api/basicInfo/elevator";
import { downloadExcel } from "@/utils/file/download";
import { useModal } from "@/components/Modal";
import InfoModal from "./InfoModal.vue";
import { formSchemas, columns, useMap } from "./info.data";
import { reactive, ref, toValue } from "vue";
import DeptTree from "./DeptTree.vue";
import UserImportModal from "./UserImportModal.vue";
import MaintanceModal from "./MaintanceModal.vue";
import AccessoriesModal from "./AccessoriesModal.vue";
import EnergyEva from "./EnergyEva.vue";
import { findLabelByValue } from "@/utils/tool";

defineOptions({ name: "Info" });

// 左边部门用
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>("");
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: "checkbox",
  },
  title: "电梯基础信息;列表",
  api: infoList,
  showIndexColumn: true,
  rowKey: "id",
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = "";
      await reload();
    },
  },
  columns: columns,
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
  actionColumn: {
    width: 250,
    title: "操作",
    key: "action",
    fixed: "right",
  },
});

const [registerModal, { openModal }] = useModal();
const [registerImportModal, { openModal: openImportModal }] = useModal();
const [registerMaintanceModal, { openModal: openMaintanceModal }] = useModal();
const [registerAccessModal, { openModal: openAccessModal }] = useModal();
const [registerEnergyModal, { openModal: openEnergyModal }] = useModal();

function handleEdit(record: Recordable) {
  openModal(true, { record, update: 1 });
}
function handleOpenAuth() {
  openMaintanceModal(true);
}
function handleAdd() {
  openModal(true, { update: 2 });
}
function handCheck(record: Recordable) {
  openModal(true, { record, update: 3 });
}
function handleImport() {
  openImportModal(true);
}
function handleOpenAccess(record: Recordable) {
  openAccessModal(true, { record });
}
function handleOpenEnergy() {
  openEnergyModal(true);
}
async function handleDelete(record: Recordable) {
  await infoRemove([record.id]);
  await reload();
}
</script>

<style scoped></style>
